// compile: gcc -Wall OperatorOverloading-CSoln.c -o OperatorOverloading-CSoln

#include <stdio.h>

typedef struct Object {
  float x;
} Object;

void Object_init  (Object *const this, const float x) { this->x = x; }
void Object_deinit(Object *const this)                { }

void Object_set(Object *const this, const Object *x) { this->x = x->x; }

void Object_mult(Object *const z, const Object *x,const Object *const y) { z->x = x->x*y->x; }
void Object_plus(Object *const z, const Object *x,const Object *const y) { z->x = x->x+y->x; }

void Object_print(const Object *const this) { printf("%g\n",this->x); }


int main() {
  Object x;  Object_init(&x,2.1);
  Object y;  Object_init(&y,4.2);
  Object z;  Object_init(&z,5.1);

  Object t1;
  Object t2;
  Object_plus(&t1, &x ,&y);
  Object_plus(&t2, &t1,&z);
  Object_print(&t2);

  return 0;
}
